Index: /devel/C/pbs_ifl.h
===================================================================
--- /devel/C/pbs_ifl.h	(revision 317)
+++ /devel/C/pbs_ifl.h	(revision 318)
@@ -91,4 +91,5 @@
 #define ATTR_v "Variable_List"
 #define ATTR_A "Account_Name"
+#define ATTR_args "job_arguments"
 #define ATTR_M "Mail_Users"
 #define ATTR_N "Job_Name"
@@ -99,4 +100,6 @@
 #define ATTR_stageout "stageout"
 #define ATTR_jobtype  "jobtype"
+#define ATTR_submit_host "submit_host"
+#define ATTR_init_work_dir "init_work_dir"
 
 /* additional job and general attribute names */
@@ -144,8 +147,16 @@
 #define ATTR_reported    "reported"
 #define ATTR_intcmd      "inter_cmd"
+#define ATTR_P           "proxy_user"
+#define ATTR_exec_gpus   "exec_gpus"
+#define ATTR_J           "job_id"
 
 #ifdef USEJOBCREATE
 #define ATTR_pagg         "pagg_id"
 #endif /* USEJOBCREATE */
+
+#ifdef NVIDIA_GPUS
+  /* JOB_ATR_gpu_flags */
+#define ATTR_gpu_flags         "gpu_flags"
+#endif  /* NVIDIA_GPUS */
 
 /* additional queue attributes names */
@@ -159,4 +170,5 @@
 #define ATTR_altrouter  "alt_router"
 #define ATTR_checkpoint_min  "checkpoint_min"
+#define ATTR_checkpoint_defaults  "checkpoint_defaults"
 #define ATTR_enable     "enabled"
 #define ATTR_fromroute  "from_route_only"
@@ -253,5 +265,20 @@
 #define ATTR_LockfileCheckTime "lock_file_check_time"
 #define ATTR_npdefault  "np_default"
+#define ATTR_clonebatchsize "clone_batch_size"
+#define ATTR_clonebatchdelay "clone_batch_delay"
 #define ATTR_jobstarttimeout "job_start_timeout"
+#define ATTR_jobforcecanceltime "job_force_cancel_time"
+#define ATTR_maxarraysize    "max_job_array_size"
+#define ATTR_maxslotlimit    "max_slot_limit"
+#define ATTR_recordjobinfo   "record_job_info"
+#define ATTR_recordjobscript   "record_job_script"
+#define ATTR_joblogfilemaxsize "job_log_file_max_size"
+#define ATTR_joblogfilerolldepth "job_log_file_roll_depth"
+#define ATTR_joblogkeepdays  "job_log_keep_days"
+#ifdef MUNGE_AUTH
+  #define ATTR_authusers       "authorized_users"
+#endif
+#define ATTR_moabarraycompatible "moab_array_compatible"
+#define ATTR_nomailforce       "no_mail_force"
 
 /* additional node "attributes" names */
@@ -264,4 +291,6 @@
 #define ATTR_NODE_status        "status"
 #define ATTR_NODE_note          "note"
+#define ATTR_NODE_gpus           "gpus"
+#define ATTR_NODE_gpustatus      "gpu_status"
 
 /* notification email formating */
@@ -278,27 +307,39 @@
 #define MAIL_AT_ABORT "a"
 
-
-#define DELDELAY  "deldelay=" /* see qdel.c */
-#define DELPURGE  "delpurge="   /* see qdel.c */
-#define PURGECOMP  "purgecomplete="   /* see req_delete.c */
-#define EXECQUEONLY  "exec_queue_only"   /* see req_stat.c */
+#define ARRAY_RANGE "array_range="      /* see qdel.c */
+#define DELDELAY  "deldelay="           /* see qdel.c */
+#define DELPURGE  "delpurge="           /* see qdel.c */
+#define DELASYNC  "delasync"            /* see qdel.c */
+#define PURGECOMP  "purgecomplete="     /* see req_delete.c */
+#define EXECQUEONLY  "exec_queue_only"  /* see req_stat.c */
+
 #define RERUNFORCE "force"
 
-#define USER_HOLD "u"
-#define OTHER_HOLD "o"
+#define USER_HOLD   "u"
+#define OTHER_HOLD  "o"
 #define SYSTEM_HOLD "s"
 
 /* node-attribute values (state,ntype) */
 
-#define ND_free   "free"
-#define ND_offline  "offline"
-#define ND_down   "down"
-#define ND_reserve  "reserve"
+#define ND_free          "free"
+#define ND_offline       "offline"
+#define ND_down          "down"
+#define ND_reserve       "reserve"
 #define ND_job_exclusive "job-exclusive"
-#define ND_job_sharing  "job-sharing"
-#define ND_busy   "busy"
+#define ND_job_sharing   "job-sharing"
+#define ND_busy          "busy"
 #define ND_state_unknown "state-unknown"
-#define ND_timeshared  "time-shared"
-#define ND_cluster  "cluster"
+#define ND_timeshared    "time-shared"
+
+/* these are not state values, they describe states and are used in pbsnodes */
+/* active = job-exclusive, job-sharing, or busy */
+#define ND_active        "active"
+/* all = all */
+#define ND_all           "all"
+/* up = job-execlusive, job-sharing, reserve, free, busy and time-shared */
+#define ND_up            "up"
+
+/* this specifies the type of node */
+#define ND_cluster "cluster"
 
 /* queue disallowed types */
@@ -360,7 +401,8 @@
 #define PBS_MAXUSER  32 /* max user name length */
 #define PBS_MAXGRPN  16 /* max group name length */
+#define PBS_MAXGPUID 16 /* max gpu id length */
 #define PBS_MAXQUEUENAME 15 /* max queue name length */
 #define PBS_MAXSERVERNAME PBS_MAXHOSTNAME /* max server name length */
-#define PBS_MAXJOBARRAYLEN      6       /* number of characters allowed in jobarray portion of job id, including '-' */
+#define PBS_MAXJOBARRAYLEN      7      /* number of characters allowed in jobarray portion of job id, including '[]' */ 
 #define PBS_MAXSEQNUM  8 /* max sequence number length */
 #define PBS_MAXPORTNUM  5 /* udp/tcp port numbers max=16 bits */
@@ -380,5 +422,5 @@
    which is added to the last version encoded that way */
 #define PBS_QS_VERSION_BASE 0x00020300 /* magic number do not change */
-#define PBS_QS_VERSION_INT 1 /* increment this version number with every change to the ji_qs struct */
+#define PBS_QS_VERSION_INT 2 /* increment this version number with every change to the ji_qs struct */
 #define PBS_QS_VERSION  (PBS_QS_VERSION_BASE + PBS_QS_VERSION_INT) /* version number saved in the ji_qs struct */
 
@@ -423,6 +465,7 @@
 #define MOM_DEFAULT_CHECKPOINT_DIR "$MOMDEFAULTCHECKPOINTDIR$"
 
-
-enum batch_op { SET, UNSET, INCR, DECR, EQ, NE, GE, GT, LE, LT, DFLT, MERGE };
+#define NO_MOM_RELAY 1
+
+enum batch_op { SET, UNSET, INCR, DECR, EQ, NE, GE, GT, LE, LT, DFLT, MERGE, INCR_OLD };
 
 /*
Index: /devel/README
===================================================================
--- /devel/README	(revision 317)
+++ /devel/README	(revision 318)
@@ -6,3 +6,3 @@
 
 If you want to assist in the development of the pbs_python package ask for write access:
- * email: pbs_python@susrfsara.nl
+ * email: pbs_python@surfsara.nl
Index: /devel/pbs_node_info
===================================================================
--- /devel/pbs_node_info	(revision 317)
+++ /devel/pbs_node_info	(revision 318)
@@ -11,4 +11,9 @@
 
   nodes = pbs.pbs_statnode(c, '', 'NULL', 'NULL')
+  e, txt=  pbs.error()
+  if e:
+    print txt
+
+  sys.exit(1)
 
   for node in nodes:
